const React = require('react');

var ProgressBar = module.exports = React.createClass({
    render: function()
    {
        return <div className="progress-bar" ref="pbar" style={{ display: this.props.text ? '' : 'none' }}>
            <div className="pending" style={{ width: this.state.width }}>{this.props.text} ({this.props.progress||0}%)</div>
            <div className="clip" style={{ width: (this.props.progress||0)+'%', overflow: 'hidden' }}>
                <div className="done" ref="pdone" style={{ width: this.state.width }}>{this.props.text} ({this.props.progress||0}%)</div>
            </div>
        </div>
    },
    componentDidUpdate: function(prevProps, prevState)
    {
        if (!prevState.width)
        {
            setTimeout(this.onResize, 50);
        }
    },
    getInitialState: function()
    {
        return { width: '' };
    },
    onResize: function()
    {
        this.setState({ width: this.refs.pbar.offsetWidth });
    },
    componentDidMount: function()
    {
        window.addEventListener('resize', this.onResize);
        this.onResize();
    },
    componentWillUnmount: function()
    {
        window.removeEventListener('resize', this.onResize);
    }
});
